#include <FastLED.h>
#include <PlainProtocol.h>
#include <Metro.h>

#define SOUND_PIN   A2
#define LED_PIN     5
#define NUM_LEDS    170
#define BRIGHTNESS  150  //max is 255
#define LED_TYPE    WS2811
#define COLOR_ORDER GRB

float H = 0, S = 0, V = 0;
int h;
int Red = 0, Green = 0, Blue = 0;
float oldRed = 0, oldGreen = 0, oldBlue = 0;
int oldstyle = 0 , newstyle = 0;
int sound = 0;
//PlainProtocol BLUNOPlainProtocol(Serial,115200);
PlainProtocol BLUNOPlainProtocol;
Metro ledMetroSpeed = Metro(100);
Metro reciveMetroLed = Metro(25);
Metro readSound = Metro(200);
CRGB leds[NUM_LEDS];
CRGBPalette16 currentPalette;
TBlendType currentBlending ;

int Style_LED = 0;  //LED MODE

void setup() {
  //LedStripInit
  Serial.begin(115200);
  BLUNOPlainProtocol.init();
  FastLED.addLeds<LED_TYPE, LED_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip );
  FastLED.setBrightness(BRIGHTNESS);
  FastLED.clear(true);
  FastLED.show();
}

void loop() {

//  static long time1 = 0;
//  time1  =  millis();
  
  bluetoothRecive();

  if (ledMetroSpeed.check() == 1)
  {
//    Serial.println(" i am in!");
    if (Style_LED == 2)
    {
      breath(30); 
//      Serial.println("breath end");
    }
   else if (Style_LED == 1 )
    {
      stream();    
//      Serial.println("stream end");
    }
  }
  if(readSound.check() == 1)
  {
      if(analogRead(SOUND_PIN) > 150)
      {
//     Serial.println(analogRead(SOUND_PIN));
        breathFast();
      }
  }
  
//  time1 = millis() - time1;
//  Serial.println(time1);
}

/*Set color and brightness*/
void FillLEDsFromPaletteColors( uint8_t colorIndex, int brightness1)
{
  for ( int i = 0; i < NUM_LEDS; i++) {
    leds[i] = ColorFromPalette(currentPalette, colorIndex, brightness1, currentBlending);
    colorIndex += 5; //How many LEDs light the same color(int this sample is 15/5);
  }
}

void stream()
{
  //  ledMetroStreamSpeed.reset();
  //  Serial.println("stream");
  static uint8_t startIndex_Stream = 0;
  startIndex_Stream = startIndex_Stream + 5; //all color  move 5 leds once time   
  ledColor();
  currentBlending = BLEND;  //LED color between on  two colors is blend or not
  FillLEDsFromPaletteColors(startIndex_Stream, 255);
  FastLED.show();
  //ledMetroStreamSpeed.interval(streamSpeed);
}

/*adjust led color range*/
void ledColor()
{
  const int value = 8;
  if (newstyle != oldstyle)
  {
    Rgb2Hsv(Red, Green, Blue, H, S, V);
    h = (int)H;
    // Serial.println(h);
    for (int i = 0; i < 16; i++)
    {
      static int m = 0;
      h = (h + value) % 360;
      m = map(h, 0, 360, 0, 255);   
      currentPalette[i] = CHSV( m, 255, 255);
      //    delay(100);
    }
//      Serial.print(h);
//      Serial.println("  ");
    //    Serial.println();
  }
}


void breath(int ledSpeed)
{
  //ledMetroBreathSpeed.reset();
  static int brightness1 = 0;
  static int flag = 0;
  static uint8_t startIndex_Breath = 0;
  //startIndex_Breath = startIndex_Breath + 3; /* motion speed */
  static uint8_t circleTime = 0;
  ledColor();
  currentBlending = NOBLEND;  
  if (flag == 0)
  {
    brightness1 += ledSpeed ;
    if (brightness1 >= 255)
    {
      brightness1 = 254;
      flag = 1;
      circleTime = 1;
    }
  }
  else if (flag == 1)
  {
    brightness1 = 255 - ledSpeed * circleTime++ ;
    if (brightness1 <= 0)
    {
      brightness1 = 1; flag = 0; circleTime = 1;
    }
  }
  //Serial.println("breath");
  FillLEDsFromPaletteColors(startIndex_Breath, brightness1);
  FastLED.show();
  //ledMetroBreathSpeed.interval(breathSpeed);
}




void Rgb2Hsv(int R, int G, int B, float& H, float& S, float& V)
{
  float min1, max1, delta, tmp;
  tmp = min(R, G);
  min1 = min(tmp, B);
  tmp = max(R, G);
  max1 = max(tmp, B);
  V = max1; // v

  delta = max1 - min1;

  if ( max1 != 0 )
    S = delta / max1; // s
  else
  {
    // r = g = b = 0 // s = 0, v is undefined
    S = 0;
    H = 0;
    return;
  }
  if ( R == max1 )
    H = ( G - B ) / delta; // between yellow & magenta
  else if ( G == max1 )
    H = 2 + ( B - R ) / delta; // between cyan & yellow
  else
    H = 4 + ( R - G ) / delta; // between magenta & cyan

  H *= 60; // degrees
  if ( H < 0 )
    H += 360;
  //  H *= 42.667; // degrees
  //  if( H < 0 )
  //     H += 256;
}

void breathFast()
{
  for (int i = 0; i < 10; i++)
  {
    FastLED.clear(true);
    delay(100);
    static uint8_t startIndex_Stream = 0;
    ledColor();
    currentBlending = NOBLEND;  
    FillLEDsFromPaletteColors(startIndex_Stream, 255);
    FastLED.show();
    delay(100);
  }
}


void bluetoothRecive()
{
  if (BLUNOPlainProtocol.receiveFrame())
  {
    if (BLUNOPlainProtocol.receivedCommand == "BUZZER" )
    {
      if (BLUNOPlainProtocol.receivedContent[0] == 1)
      {
        Style_LED = 1;     //Water lamp mode
//        Serial.println("BUZZER = 1");
      }
      else
        Style_LED = 2;    //Breathing light mode
//        Serial.println("BUZZER = 0");
    }
    if (BLUNOPlainProtocol.receivedCommand == "RGBLED" ) //get command of  "RGB"
    {
      Red  = BLUNOPlainProtocol.receivedContent[0];
      Green = BLUNOPlainProtocol.receivedContent[1];
      Blue = BLUNOPlainProtocol.receivedContent[2];
//      Serial.print(Red);
//      Serial.print("  ");
//      Serial.print(Green);
//      Serial.print("  ");
//      Serial.println(Blue);
      //      delay(4);
      if (Red == oldRed && Green == oldGreen && Blue == oldBlue)  //judge the choose color is changeing or not 
      {
        oldstyle = newstyle;
        //        Serial.println("oldRGB");
      }
      else
      {
        oldstyle = newstyle;
        newstyle = oldstyle + 1;
        //       Serial.println("newRGB");
      }
      oldRed = Red;
      oldGreen = Green;
      oldBlue = Blue;
    }
  }
}


